//+------------------------------------------------------------------+
//|                                                          SID.mq4 |
//|                                     Copyright  2012, J. L. Hunt |
//|                                                                  |
//| Sid the Superstitious Robot                                      |
//| Version 1.00                                                     |
//|                                                                  |
//| This program is free software: you can redistribute it and/or    |
//| modify it under the terms of the GNU General Public License      |
//| as published by the Free Software Foundation, either version 3   |
//| of the License, or (at your option) any later version.           |
//|                                                                  |
//| This program is distributed in the hope that it will be useful,  |
//| but WITHOUT ANY WARRANTY; without even the implied warranty of   |
//| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the     |
//| GNU General Public License for more details.                     |
//|                                                                  |
//| You should have received a copy of the GNU General Public        |
//| License along with this program.                                 |
//| If not, see <http://www.gnu.org/licenses/gpl.html>               |
//|                                                                  |
//| Wealth Warning! This expert is for educational purposes only.    |
//| It should NEVER be used on a live account. Past performance is   |
//| in no way indicative of future results!                          |
//|                                                                  |
//| Concept for Sid the Superstitious Robot and for                  |
//| 'The Superstitious Fund Project', by Shing Tat Chung             |
//|                   http://asuperstitiousfund.com/                 |
//|                   http://superstitiousthoughts.com/              |
//|                   http://shingtatchung.com/                      |
//|                                                                  |
//| MetaTrader 4 implementation by Jim Hunt                          |
//|                   http://community.trading-gurus.com/threads/204 |
//+------------------------------------------------------------------+
//+ Revision History                                                 +
//+                                                                  +
//+ 1.00 - June 20th 2012                                            +
//+        First release version                                     +
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, J. L. Hunt"
#property link      "http://community.trading-gurus.com/threads/204"

#define ROBOT_NAME   "SID"
#define VERSION      "v1.00"

#define SLEEP_WAIT   50
#define SLEEP_OK     250
#define SLEEP_ERR    250

#define SECS_PER_MIN  60
#define SECS_PER_HOUR 3600
#define SECS_PER_DAY  86400

#define MAX_NOS      5
#define MAX_ORDERS   3

#define ORDER_NO     0
#define ORDER_STATUS 1
#define ENTRY_TYPE   2
#define MAX_FIELDS   3

#define ORDER_PENDING 1
#define ORDER_FILLED  2
#define ORDER_CLOSED  3

#define ENTRY_LUCKY_NO        0
#define ENTRY_LUCKY_MOON      1
#define ENTRY_FRIDAY_THIRTEEN 2
#define ENTRY_MOON_PHASE      3
#define MAX_ENTRIES           4

#import "libmysql.dll"
int    mysql_init(int handle); 
int    mysql_real_connect(int handle,string host, string user, string password, string schema, int port, int socket, int clientflag); 
int    mysql_real_query(int handle, string query, int length); 
void   mysql_close(int handle); 
int    mysql_errno(int handle); 
string mysql_error(int handle); 

int    mysql_store_result(int handle); 
int    mysql_num_rows(int result); 
string mysql_fetch_row(int result); 
void   mysql_free_result(int result); 
#import

//---- Input parameters
extern int     MaxSlippage = 2;     // Maximum acceptable slippage on a market order
extern double  Lots1 = 0.5;         // Size of each order
extern int     ProfitTarget1 = 80;  // Fixed take profit target  
extern int     StopLoss1 = 25;      // Fixed stop loss            
extern double  Lots2 = 1.0;
extern int     ProfitTarget2 = 80;  
extern int     StopLoss2 = 25;            
extern double  Lots3 = 3.0;
extern int     ProfitTarget3 = 90;  
extern int     StopLoss3 = 35;            
extern int     FinishHour = 21;     // Finish time for entry orders
extern int     FinishMins = 00;     //  Set FinishHours >= 24 to disable
extern int     CloseHour = 21;      // Time to close all positions (24:00 means never!)
extern int     CloseMins = 55;      //
extern int     MinRepeatMins = 120; // Minimum interval between identical entries (in minutes)
extern int     MinReverseMins = 150;// Minimum interval between entries in opposite directions (in minutes)
extern int     LuckyPrice = -1;     // User lucky number            
extern int     UnluckyPrice = -1;   // User unlucky number            
extern int     UnluckyDay = -1;     // User unlucky date           
extern bool    StpMode = FALSE;     // Set TRUE for brokers that don't accept market orders with built in stops
extern bool    UseLog = true;       // Set TRUE for extra debug messages
extern bool    UseMySQL = true;     // Set TRUE to save trading history in a MySQL database
extern int     SummaryPeriod = 300; // Time interval between writing new summary info to database (in seconds)
extern int     TimeOffset = 1;      // Broker's time offset from UK time (in hours)
extern string  host = "localhost";  // MySQL server host
extern int     port = 3306;         // MySQL server port
extern string  schema = "SuperstitiousSid";  // MySQL database name
extern string  user = "admin";      // MySQL username
extern string  password = "abc123"; // MySQL password

//---- static variables
static int     Magic = 76543;
static int     Dig;
static double  Points;
static string  Suffix;
static string  Broker;
static bool    SmartFix = FALSE;

static bool    Initialized = FALSE;
static bool    Running = FALSE;
static bool    Started = FALSE;
static bool    LongFinished = TRUE;
static bool    ShortFinished = TRUE;
static bool    LongValid = FALSE;
static bool    ShortValid = FALSE;
static int     StopLevel;
static double  MinLots;
static double  MaxLots;
static double  StepLots;
static double  TickSize;
static int     Spread;
static int     Slippage;
static int     Target;
static int     Stop;
static string  StrategyName;
static int     LastBar;
static int     LastDay;
static int     LastMonth;
static int     MaxMonthlyLoss = 12;
static datetime FinishDate;
static int     DaysLeft = 0;
static int     HoursLeft = 0;
static string  AskStr;
static string  BidStr;
static datetime   FinishTime;      // Entry Finish Time
static datetime   CloseTime;       // Position Close Time
static datetime   PhaseTime;       // Time of moon phase
static datetime   NextSummary;     // Time to write next summary to the database
static datetime   StartTimes[MAX_ENTRIES];

static double  Lots;

static int     Orders[MAX_ORDERS][MAX_FIELDS];
static int     LuckyPrices[MAX_NOS] = {168, 888, -1, -1, -1};
static int     UnluckyPrices[MAX_NOS] = {13, 666, -1, -1, -1};
static int     LongFilter[MAX_NOS] = {4, 13, 17, -1, -1};
static int     LongBadDay[MAX_NOS] = {4, 13, -1, -1, -1};
static int     LuckyOffset;
static int     UnluckyOffset;
static int     mysql = 0;
static string  PhaseStr = "X"; 
static double  OriginalEquity = 0.0;
static double  MonthlyMinimum = 0.0;

static color   clBuy = DodgerBlue;
static color   clSell = Crimson;

//+------------------------------------------------------------------+
//| Utility functions                                                |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| Expert helper functions                                          |
//+------------------------------------------------------------------+

int mod(int a, int b) {

   while (a < 0)
     a += b;
     
   return(a - b * (a / b));
}

//+------------------------------------------------------------------+
//| int TradeAllowed( int MaxWaiting_sec = 30 )
//|
//| the function checks the trade context status. Return codes:
//|  1 - trade context is free, trade allowed
//|  0 - trade context was busy, but became free. Trade is allowed only after 
//|      the market info has been refreshed.
//| -1 - trade context is busy, waiting interrupted by the user (expert was removed from 
//|      the chart, terminal was shut down, the chart period and/or symbol was changed, etc.)
//| -2 - trade context is busy, the waiting limit is reached (MaxWaiting_sec). 
//|      Possibly, the expert is not allowed to trade (checkbox "Allow live trading" 
//|      in the expert settings).
//|
//| MaxWaiting_sec - time (in seconds) within which the function will wait 
//| until the trade context is free (if it is busy). By default,30.
//+------------------------------------------------------------------+
int TradeAllowed(int MaxWaiting_sec = 30)
{
   // check whether the trade context is free
   if(IsTradeAllowed()) {
      return(1);
   }
   else {
     int StartWaitingTime = GetTickCount();
     
     Print("Trade context is busy! Wait until it is free...");
     
     while(true)        // infinite loop
       {
         // if the expert was terminated by the user, stop operation
         if(IsStopped()) 
           { 
             Print("The expert was terminated by the user!"); 
             return(-1); 
           }
         // if the waiting time exceeds the time specified in the 
         // MaxWaiting_sec variable, stop operation, as well
         if(GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000)
           {
             Print("The waiting limit exceeded (" + MaxWaiting_sec + " ???.)!");
             return(-2);
           }
         // if the trade context has become free,
         if(IsTradeAllowed())
           {
             Print("Trade context has become free!");
             return(0);
           }
         // if no loop breaking condition has been met, "wait" for 0.1 
         // second and then restart checking
         Sleep(SLEEP_WAIT);
       }
   }
}

//+------------------------------------------------------------------+
//| Places a market order                                            |
//+------------------------------------------------------------------+
int MarketOrder(string symbol, int Type, double Entry, double Quantity, 
          double TargetPrice, double StopPrice, string comment = "") 
{
   string TypeStr;
   color  TypeCol;
   int    ErrorCode, Ticket;
   double Price, FillPrice;
   
   if (comment == "")
      comment = StrategyName;
      
   Price = NormalizeDouble(Entry, Dig);
   
   switch (Type) {
      case OP_BUY: 
         TypeStr = "BUY";
         TypeCol = clBuy;
         break; 
      case OP_SELL: 
         TypeStr = "SELL";
         TypeCol = clSell;
         break;
      default:    
         Print("Unknown order type ", Type);
         break; 
   }
      
   if (TradeAllowed() < 0)
      return (-1);
      
   if (StpMode) {
      Ticket = OrderSend(symbol, Type, Quantity, Price, Slippage,
               0, 0, comment, Magic, 0, TypeCol);
   }
   else {
      Ticket = OrderSend(symbol, Type, Quantity, Price, Slippage,
               StopPrice, TargetPrice, comment, Magic, 0, TypeCol);
   }
         
   if (Ticket >= 0) {
      Print("Opened ", TypeStr, " order: ", Ticket, ", Entry = ", DoubleToStr(Price, Dig),
            ", Target = ", DoubleToStr(TargetPrice, Dig), ", Stop = ", DoubleToStr(StopPrice, Dig),
            ", Current Bid = ", DoubleToStr(Bid, Dig), ", Current Ask = ", DoubleToStr(Ask, Dig));
      Sleep(SLEEP_OK);
      if (OrderSelect(Ticket, SELECT_BY_TICKET) == TRUE) {
         FillPrice = OrderOpenPrice();
         if (Entry != FillPrice) {
            RefreshRates();
            Print("Slippage on order ", Ticket, " - Requested = ",
                  DoubleToStr(Entry, Dig), ", Fill = ", DoubleToStr(FillPrice, Dig),
                  ", Current Bid = ", DoubleToStr(Bid, Dig), ", Current Ask = ", DoubleToStr(Ask, Dig));
         }
         if (StpMode && ((StopPrice > 0) || (TargetPrice > 0))) {         
            if (OrderModify(Ticket, FillPrice, StopPrice, TargetPrice, 0, TypeCol)) {
               Sleep(SLEEP_OK);
               return (Ticket);
            } 	
   	   }
      }
      else {
         ErrorCode = GetLastError();
         Print("Error selecting new order ", Ticket, ": ",
               ErrorDescription(ErrorCode), " (", ErrorCode, ")");
      }
      return (Ticket);
   } 	
   	
   ErrorCode = GetLastError();
   RefreshRates();
   Print("Error opening ", TypeStr, " order: ", ErrorDescription(ErrorCode),
         " (", ErrorCode, ")", ", Entry = ", Price, ", Target = ",
         TargetPrice, ", Stop = ", StopPrice, ", Current Bid = ", Bid,
         ", Current Ask = ", Ask);
   Sleep(SLEEP_ERR);
	
   return (-1);
}
  
//+------------------------------------------------------------------+
//| Closes an order at market price                                  |
//+------------------------------------------------------------------+
int CloseMarket(int Ticket)
{
   int    Type, ErrorCode;
   double Price, Quantity;
   string TypeStr;
   
   OrderSelect(Ticket, SELECT_BY_TICKET);
   Type = OrderType(); 
      
   Quantity = OrderLots();
   
   while (TRUE) {             // Keep trying until the order really is closed
      switch (Type) {
         case OP_BUY: 
            TypeStr = "BUY";
            Price=Bid;
            break; 
         case OP_SELL: 
            TypeStr = "SELL";
            Price=Ask;
            break;
         default:    
            Print("Cannot close order type ", Type);
            return (-1);
            break; 
      }
      
      if (TradeAllowed() < 0)
         continue;

      Print("CLOSE ", TypeStr, " order ", Ticket, ", ", Quantity, ", ", Price);
      if (OrderClose(Ticket, Quantity, NormalizeDouble(Price, Dig), 0, CLR_NONE) == TRUE) {
         Sleep(SLEEP_OK);
         return (0);
      }
      else {   
         ErrorCode = GetLastError();
         Print("Error closing order ", Ticket, ": ", ErrorDescription(ErrorCode),
               " (", ErrorCode, ")", " size: ", Quantity, ", prices: ",
               Price, ", ", Bid, ", ", Ask);
         if (ErrorCode == 4108)  // Ticket no longer exists - Just hit built in stop also
            return (-1);
               
         Sleep(SLEEP_ERR);
         RefreshRates();
      }      
   }
   return (-1);
}
   
//+------------------------------------------------------------------+
//| Close all open orders                                            |
//+------------------------------------------------------------------+
void EmergencyStop()
{
   for(int i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) {
         switch(OrderType()) {
         case OP_BUY:
         case OP_SELL:
           CloseMarket(OrderTicket());
           Alert("Warning - Emergency close of order ", OrderTicket());
           break; 
         default:    
            Print("Found order ", OrderTicket(), " with unexpected order type ", OrderType());
            break; 
         }
      }
   }
}

double FindMonthlyMinimum()
{
   double Balance = 0.0;
   double Minimum;
   int ThisYear = TimeYear(TimeCurrent());
   int ThisMonth = TimeMonth(TimeCurrent());
   datetime StartDate = StrToTime(StringConcatenate(ThisYear, ".", ThisMonth, ".1"));

   if (IsTesting())     // Tester doesn't record original balance as an "order"
      Balance = OriginalEquity;   
   for (int Index = 0; Index < OrdersHistoryTotal() - 1; Index++) {
      OrderSelect(Index, SELECT_BY_POS, MODE_HISTORY);
      if (OrderOpenTime() > StartDate)
         break;   
      Balance = Balance + OrderProfit() + OrderSwap() + OrderCommission();
   }
   Minimum = Balance * (1 - 0.01 * MaxMonthlyLoss);
   Print("Balance at start of month = ", DoubleToStr(Balance, 2), ", Minimum for this month = ", DoubleToStr(Minimum, 2));
   return (Minimum);   
}

void db_connect() { 
   mysql = mysql_init(0); 
   if (mysql == 0) {
      Print("MySQL initialisation error");
      return; 
   }
   else
      Print("MySQL initialised"); 
   int res = mysql_real_connect(mysql, host, user, password, schema, port,"", 0); 
   if (res == mysql)
      Print("MySQL connected"); 
   else
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ")"); 
} 

void db_disconnect() { 
   mysql_close(mysql);
   mysql = 0; 
   Print("MySQL disconnected"); 
}

string MySqlTime(datetime MT4Time)
{
   string retVal = TimeToStr(MT4Time, TIME_DATE | TIME_SECONDS);
   return (retVal);
}

//+------------------------------------------------------------------+
//| Writes selected order details to database                        |
//+------------------------------------------------------------------+
void db_writeOrder()
{
   string TypeStr;
   
   switch (OrderType()) {
      case OP_BUY: 
         TypeStr = "Buy";
         break; 
      case OP_SELL: 
         TypeStr = "Sell";
         break;
      default:    
         Print("Unknown order type ", OrderType());
         break; 
   }
      
   string query = StringConcatenate("insert into Trades values (0,\'", Broker, "\',", AccountNumber(), ",",
             OrderMagicNumber(), ",\'",  StrategyName, "\',\'", OrderSymbol(), "\',",
             OrderTicket(), ",", DoubleToStr(OrderLots(), 3), ",\'", TypeStr, "\',",  
             DoubleToStr(OrderOpenPrice(), Dig), ",\'", MySqlTime(OrderOpenTime()), "\',", 
             DoubleToStr(OrderClosePrice(), Dig), ",\'", MySqlTime(OrderCloseTime()), "\',", 
             DoubleToStr(OrderProfit(), 2), ",", DoubleToStr(AccountEquity(), 2), ")");

   if (mysql_real_query(mysql, query, StringLen(query)) != 0) {
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") inserting trade to host " + host);
      Print("Query = ", query);
   }   
}

//+------------------------------------------------------------------+
//| Increments lucky number rank in database                         |
//+------------------------------------------------------------------+
void db_incRank(int i)
{
   string query = StringConcatenate("update LuckyNumbers set `Rank` = `Rank` + 1, `LastTime` = \'", MySqlTime(TimeCurrent()), "\' where `Number` = ", i);

   if (i == 0)
      return;              // Don't allow 00 to be a lucky/unlucky number
      
   if (mysql_real_query(mysql, query, StringLen(query)) != 0) {
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") incrementing lucky number on host " + host);
      Print("Query = ", query);
   }   
}
   
//+------------------------------------------------------------------+
//| Decrements lucky number rank in database                         |
//+------------------------------------------------------------------+
void db_decRank(int i)
{
   string query = StringConcatenate("update LuckyNumbers set `Rank` = `Rank` - 1, `LastTime` = \'", MySqlTime(TimeCurrent()), "\' where `Number` = ", i);

   if (i == 0)
      return;              // Don't allow 00 to be a lucky/unlucky number
      
   if (mysql_real_query(mysql, query, StringLen(query)) != 0) {
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") decrementing lucky number on host " + host);
      Print("Query = ", query);
   }   
}
   
//+------------------------------------------------------------------+
//| Reads generated lucky number rank from database                  |
//+------------------------------------------------------------------+
int db_read_lucky() { 
   string row; 
   int retVal = -1;
   
   string query="Select concat(';',concat_ws(';', Number)) from LuckyNumbers where `Rank` > 0 and `Rank`=(select max(`Rank`) from LuckyNumbers) order by `LastTime`";
   int length = StringLen(query); 
   if (mysql_real_query(mysql, query, length) != 0) { 
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") reading lucky numbers from host " + host);
      Print("Query = ", query);
      return (retVal); 
   }
   
   int result = mysql_store_result(mysql); 
   if (mysql_num_rows(result) > 0) { 
      row = mysql_fetch_row(result);
      int begin = StringFind(row, ";") + 1;
      while (begin > 0) {
         length = StringLen(row);
         row = StringSubstr(row, begin, length - begin); 
         begin = StringFind(row, ";") + 1;
      }   
      retVal = StrToInteger(row);
   } 
   mysql_free_result(result);
   
   return (retVal); 
}

//+------------------------------------------------------------------+
//| Reads generated unlucky number rank from database                |
//+------------------------------------------------------------------+
int db_read_unlucky() { 
   string row; 
   int retVal = -1;

   string query="Select concat(';',concat_ws(';', Number)) from LuckyNumbers where `Rank` < 0 and `Rank`=(select min(`Rank`) from LuckyNumbers) order by `LastTime`";
   int length = StringLen(query); 
   if (mysql_real_query(mysql, query, length) != 0) { 
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") reading unlucky numbers from host " + host);
      Print("Query = ", query);
      return (retVal); 
   }

   int result = mysql_store_result(mysql); 
   if (mysql_num_rows(result) > 0) { 
      row = mysql_fetch_row(result);
      int begin = StringFind(row, ";") + 1;
      while (begin > 0) {
         length = StringLen(row);
         row = StringSubstr(row, begin, length - begin); 
         begin = StringFind(row, ";") + 1;
      }   
      retVal = StrToInteger(row);
   } 
   mysql_free_result(result); 
   
   return (retVal); 
}

string db_read_phase(datetime StartTime) {
   string retVal = "X"; 
   string row; 
   datetime EndTime = StartTime + SECS_PER_DAY;
   
   EndTime = EndTime - mod(EndTime, SECS_PER_DAY);
   PhaseTime = EndTime;

   string query = StringConcatenate("Select concat(';',concat_ws(';', PhaseType, PhaseDate)) from MoonPhases where `PhaseDate` >= \'", MySqlTime(StartTime), "\' and `PhaseDate` < \'", MySqlTime(EndTime), "\' order by `PhaseDate`");
   int length = StringLen(query); 
   if (mysql_real_query(mysql, query, length) != 0) { 
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") reading unlucky numbers from host " + host);
      Print("Query = ", query);
      return (retVal); 
   }
   
   int result = mysql_store_result(mysql); 
   int numOfRows = mysql_num_rows(result); 
   if (mysql_num_rows(result) > 0) { 
      row = mysql_fetch_row(result);
      length = StringLen(row);
      int begin = StringFind(row, ";") + 1;
      row = StringSubstr(row, begin, length - begin); 
      Print("Moon phase: ", row); 
      length = StringLen(row);
      begin = StringFind(row, ";");
      retVal = StringSubstr(row, 0, begin);
      begin++;
      row = StringSubstr(row, begin, length - begin);
      PhaseTime = StrToTime(row); 
   } 
   mysql_free_result(result); 
   
   return (retVal); 
}

void ReadMoonPhase(datetime StartTime)
{
   db_connect();
   PhaseStr = db_read_phase(StartTime);
   db_disconnect();
}

//+------------------------------------------------------------------+
//| Reads summary info from database                                 |
//+------------------------------------------------------------------+
bool db_read_summary() { 
   string row; 
   bool retVal = false;

   string query="Select concat(';',concat_ws(';', OriginalEquity)) from `Summary`";
   int length = StringLen(query); 
   if (mysql_real_query(mysql, query, length) != 0) { 
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") reading original equity from host " + host);
      Print("Query = ", query);
      return (retVal); 
   }

   int result = mysql_store_result(mysql); 
   if (mysql_num_rows(result) > 0) { 
      row = mysql_fetch_row(result);
      int begin = StringFind(row, ";") + 1;
      while (begin > 0) {
         length = StringLen(row);
         row = StringSubstr(row, begin, length - begin); 
         begin = StringFind(row, ";") + 1;
      }   
      OriginalEquity = StrToDouble(row); 
      retVal = true;
   } 
   mysql_free_result(result); 
   
   return (retVal); 
}

//+------------------------------------------------------------------+
//| Writes summary info to database                                  |
//+------------------------------------------------------------------+
void db_write_summary()
{
   OriginalEquity = AccountEquity();
   
   string query = StringConcatenate("insert into Summary values (", DoubleToStr(OriginalEquity, 2), ",",
             DoubleToStr(AccountEquity(), 2), ",", DoubleToStr(AccountEquity() - OriginalEquity, 2), ",",
             DoubleToStr(100.0 * (AccountEquity() / OriginalEquity - 1.0), 2), ",",
             LuckyPrices[LuckyOffset], ", ", UnluckyPrices[UnluckyOffset],
             ", -1, -1, 365, 0)");

   if (mysql_real_query(mysql, query, StringLen(query)) != 0) {
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") inserting summary to host " + host);
      Print("Query = ", query);
   }   
   
   NextSummary = TimeCurrent() + SummaryPeriod;
}

//+------------------------------------------------------------------+
//| Updates summary info in database                                 |
//+------------------------------------------------------------------+
void db_update_summary()
{
   datetime Countdown = FinishDate - TimeCurrent();
   Countdown /= SECS_PER_HOUR;
   Countdown += TimeOffset;
   DaysLeft = Countdown / 24;
   HoursLeft = Countdown - 24 * DaysLeft;

   string query = StringConcatenate("update `Summary` set `CurrentEquity` = ", DoubleToStr(AccountEquity(), 2),
             ", `EquityChange` = ", DoubleToStr(AccountEquity() - OriginalEquity, 2),
             ", `PercentChange` = ", DoubleToStr(100.0 * (AccountEquity() / OriginalEquity - 1.0), 2),
             ", `LuckyNumber` = ", LuckyPrices[LuckyOffset], 
             ", `UnluckyNumber` = ", UnluckyPrices[UnluckyOffset],
             ", `LuckyMoon` = ", -1,
             ", `UnluckyMoon` = ", -1,
             ", `DaysLeft` = ", DaysLeft,
             ", `HoursLeft` = ", HoursLeft);

   if (mysql_real_query(mysql, query, StringLen(query)) != 0) {
      Print("MySQL error = ", mysql_error(mysql), " (", mysql_errno(mysql), ") updating summary on host " + host);
      Print("Query = ", query);
   }   
}

//+------------------------------------------------------------------+
//| Calculates position size                                         |
//+------------------------------------------------------------------+
double PositionSize()
{
   double Size, TickValue;
   
   if (SmartFix) {         // For Smart Live spread bet use 1/pip
      if ((TickSize == 0.001) || (TickSize == 0.00001))
         TickValue = 0.1;
      else   
         TickValue = 1.0;
   }
   else
      TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);

   Size = Lots;
      
   if (Size > MaxLots)
      Size = MaxLots;
   else if (Size < MinLots)
      Size = MinLots;
   else
      Size = MinLots + StepLots * MathFloor((Size - MinLots)/ StepLots);

   if (UseLog) {
      double CreditLine = AccountFreeMargin() * AccountLeverage();
      Print("Account currency = ", AccountCurrency(), ", Free Margin = ", AccountFreeMargin(), 
            ", Leverage = ", AccountLeverage(), ", Credit line = ", AccountCurrency(), " ", CreditLine);
      Print("Margin/lot = ", MarketInfo(Symbol(), MODE_MARGINREQUIRED),
            ", Lot size = ", MarketInfo(Symbol(), MODE_LOTSIZE), ", Tick Value = ", TickValue);
      Print("Current order size = ", Size);
   }

   return (Size);
}

//+------------------------------------------------------------------+
//| Performs system initialisation                                   |
//+------------------------------------------------------------------+
void InitSystem()
{
   int UnitNumber;
   
   Running = FALSE;
   
   RefreshRates();
   
   for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
      Orders[UnitNumber][ORDER_NO] = -1;
      Orders[UnitNumber][ORDER_STATUS] = ORDER_CLOSED;
   }

   UnitNumber = 0;
   for(int i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) {
         switch(OrderType()) {
         case OP_BUY:
         case OP_SELL:
           Running = TRUE;
           Orders[UnitNumber][ORDER_NO] = OrderTicket();
           Orders[UnitNumber][ORDER_STATUS] = ORDER_FILLED;
           Alert("Found open order ", Orders[UnitNumber][ORDER_NO], " for strategy ", StrategyName);
           UnitNumber++;
           break; 
         default:    
            Print("Found order ", OrderTicket(), " with unexpected order type ", OrderType());
            break; 
         }
      }
   }
   
   Initialized = TRUE;
}
         
//+------------------------------------------------------------------+
//| Checks for order status changes. Called on each tick             |
//+------------------------------------------------------------------+
int CheckOrders()
{
   int Status, Mins;
   int UnitNumber, j;
   double Profit;
   string Dirn;

   for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
      if (Orders[UnitNumber][ORDER_STATUS] == ORDER_CLOSED)
         continue;
         
      Status = CheckStatus(Orders[UnitNumber][ORDER_NO]);   // Selects the order
      if (Status > 1) {
         Profit = OrderProfit();
         Mins = TimeMinute(OrderOpenTime());
         if (UseMySQL) {
            db_connect();
            db_writeOrder();
            if (Profit > 0.0) {
               if (OrderType() == OP_BUY)
                  db_incRank(Mins);
               else
                  db_decRank(Mins);
            }
            else {
               if (OrderType() == OP_BUY)
                  db_decRank(Mins);
               else
                  db_incRank(Mins);
            }
            LuckyPrices[LuckyOffset] = db_read_lucky();
            UnluckyPrices[UnluckyOffset] = db_read_unlucky();
            db_update_summary();
            db_disconnect();
            PrintLuckyNumbers();
         }
         Print("Order ", Orders[UnitNumber][ORDER_NO], " closed at ", TimeToStr(TimeCurrent(), TIME_SECONDS),
               ", Profit = ", DoubleToStr(Profit, 2));
         Orders[UnitNumber][ORDER_STATUS] = ORDER_CLOSED;
         Orders[UnitNumber][ORDER_NO] = -1;
      }
      else if ((Orders[UnitNumber][ORDER_STATUS] >= ORDER_FILLED) && (CloseHour < 24) && (TimeCurrent() >= CloseTime)) {
         Print("Closing order ", Orders[UnitNumber][ORDER_NO], " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS),
               ", time stop ", TimeToStr(CloseTime, TIME_DATE | TIME_SECONDS));
         CloseMarket(Orders[UnitNumber][ORDER_NO]);
      }     
      
   }
}

//+------------------------------------------------------------------+
//| Checks to see if a potential trade is rejected by our filters    |
//+------------------------------------------------------------------+
bool CheckFilters(bool Short, int EntryType)
{
   int   i, UnitNumber, ErrorCode;
   string CheckStr, DateStr;
   datetime TimeDiff;

   if (TimeCurrent() < StartTimes[EntryType]) {
      Print("Entry filtered - This entry type allowed from ", TimeToStr(StartTimes[EntryType], TIME_SECONDS), " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
      return (TRUE);
   }
   
   if (Short) {
      for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
         if (Orders[UnitNumber][ORDER_STATUS] == ORDER_FILLED) {
            if (OrderSelect(Orders[UnitNumber][ORDER_NO], SELECT_BY_TICKET) != TRUE) {
               ErrorCode = GetLastError();
               Print("Error selecting order ", Orders[UnitNumber][ORDER_NO], " to check: ",
                     ErrorDescription(ErrorCode), " (", ErrorCode, ")");
               return (TRUE);
            }
            
            TimeDiff = TimeCurrent() - OrderOpenTime();
            if ((OrderType() == OP_BUY) && (TimeDiff < MinReverseMins * SECS_PER_MIN)) {
               Print("Short filtered - Already long from ", TimeToStr(OrderOpenTime(), TIME_SECONDS), " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
               return (TRUE);
            }
         }
      }
   }
   else {
      for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
         if (Orders[UnitNumber][ORDER_STATUS] == ORDER_FILLED) {
            if (OrderSelect(Orders[UnitNumber][ORDER_NO], SELECT_BY_TICKET) != TRUE) {
               ErrorCode = GetLastError();
               Print("Error selecting order ", Orders[UnitNumber][ORDER_NO], " to check: ",
                     ErrorDescription(ErrorCode), " (", ErrorCode, ")");
               return (TRUE);
            }
            
            TimeDiff = TimeCurrent() - OrderOpenTime();
            if ((OrderType() == OP_SELL) && (TimeDiff < MinReverseMins * SECS_PER_MIN)) {
               Print("Long filtered - Already short from ", TimeToStr(OrderOpenTime(), TIME_SECONDS), " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
               return (TRUE);
            }
         }
      }

      for (i = 0; i < MAX_NOS; i++) {
         if (LongFilter[i] < 0)
            break;
         
         if (LongFilter[i] < 10)
            CheckStr = StringConcatenate("0", LongFilter[i]);
         else   
            CheckStr = StringConcatenate("", LongFilter[i]);

         if (StringFind(BidStr, CheckStr, 0) >= 0) {
            Print("Long filtered - Bid = ", BidStr, ", Filter = ", CheckStr, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            return (TRUE);
         }      
         if (StringFind(AskStr, CheckStr, 0) >= 0) {
            Print("Long filtered - Ask = ", AskStr, ", Filter = ", CheckStr, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            return (TRUE);
         }
      }

      DateStr = StringConcatenate("", TimeDay(TimeCurrent()));
      for (i = 0; i < MAX_NOS; i++) {
         if (LongBadDay[i] < 0)
            break;
         
         CheckStr = StringConcatenate("", LongBadDay[i]);
         if (StringFind(DateStr, CheckStr, 0) >= 0) {
            Print("Long filtered - Day = ", DateStr, ", Filter = ", CheckStr, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            LongFinished = true;
            return (TRUE);
         }      
      }
   }      

   return(FALSE);
}

//+------------------------------------------------------------------+
//| Checks for entry to a trade                                      |
//+------------------------------------------------------------------+
bool CheckEntry()
{
   int   i, UnitNumber, EntryType;
   string CheckStr, AskStr, BidStr;
   
   if (TimeCurrent() >= FinishTime)
      return(false);
   
   if (AccountEquity() <= MonthlyMinimum)
      return(false);
      
   AskStr = DoubleToStr(Ask, 0);       // Currently specific to UK100   
   BidStr = DoubleToStr(Bid, 0);

   for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
      if (Orders[UnitNumber][ORDER_NO] <= 0)
         break;                        // Found an unused slot;
   }
   if (UnitNumber >= MAX_ORDERS) {
      return(false);
   }
   
   LongValid = FALSE;
   if (!LongFinished) {
      for (i = 0; i < MAX_NOS; i++) {
         if (LuckyPrices[i] < 0)
            break;
         
         if (LuckyPrices[i] < 10)
            CheckStr = StringConcatenate("0", LuckyPrices[i]);
         else   
            CheckStr = StringConcatenate("", LuckyPrices[i]);
         if (StringFind(BidStr, CheckStr, 0) >= 0) {
            Print("Long valid - Bid = ", BidStr, ", Lucky = ", CheckStr, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            EntryType = ENTRY_LUCKY_NO;
            LongValid = TRUE;
            if (i == LuckyOffset)
               SetParams(2);
            else if (StringLen(CheckStr) == 3) 
               SetParams(2);
            else   
               SetParams(1);
         }      
      }
      
      if ((PhaseStr != "X") && (TimeCurrent() >= PhaseTime)) {
         EntryType = ENTRY_MOON_PHASE;
         SetParams(2);
         if (PhaseStr == "D") {
            Print("Long valid - New moon at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            LongValid = TRUE;
         }
         else if (PhaseStr == "E") {
            Print("Long valid - Apogee moon at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            LongValid = TRUE;
         }
         if (LongValid)
            ReadMoonPhase(TimeCurrent() + 1);
      }
        
      if (LongValid) {
         if (!CheckFilters(FALSE, EntryType)) {
            Orders[UnitNumber][ORDER_NO] = MarketOrder(Symbol(), OP_BUY, Ask, PositionSize(),
                     Ask + Points * Target, Ask - Points * Stop);
            if (Orders[UnitNumber][ORDER_NO] > 0) {
               Print("Opened long ", Ask, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
               Orders[UnitNumber][ORDER_STATUS] = ORDER_FILLED;
               Orders[UnitNumber][ENTRY_TYPE] = EntryType;
               StartTimes[EntryType] = TimeCurrent() + MinRepeatMins * SECS_PER_MIN;
               UnitNumber++;
               LongValid = FALSE;
               return(true);
            }
         }   
      }
   }
         
   for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
      if (Orders[UnitNumber][ORDER_NO] <= 0)
         break;                        // Found an unused slot;
   }
   if (UnitNumber >= MAX_ORDERS) {
      return(false);
   }
      
   ShortValid = FALSE;
   if (!ShortFinished) {
      for (i = 0; i < MAX_NOS; i++) {
         if (UnluckyPrices[i] < 0)
            break;
         
         if (UnluckyPrices[i] < 10)
            CheckStr = StringConcatenate("0", UnluckyPrices[i]);
         else   
            CheckStr = StringConcatenate("", UnluckyPrices[i]);
         if (StringFind(AskStr, CheckStr, 0) >= 0) {
            Print("Short valid - Ask = ", AskStr, ", Unlucky = ", CheckStr, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            EntryType = ENTRY_LUCKY_NO;
            ShortValid = TRUE;
            if ((TimeDayOfWeek(TimeCurrent()) == 5) && (CheckStr == "13"))     // Today is a Friday?
               SetParams(2);
            else if (i == UnluckyOffset)
               SetParams(2);
            else if (StringLen(CheckStr) == 3) 
               SetParams(2);
            else   
               SetParams(1);
         }      
      }
   
      if ((PhaseStr != "X") && (TimeCurrent() >= PhaseTime)) {
         EntryType = ENTRY_MOON_PHASE;
         if (PhaseStr == "B") {
            Print("Short valid - Lunar eclipse at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            ShortValid = TRUE;
            SetParams(3);
         }
         else if (PhaseStr == "C") {
            Print("Short valid - Solar eclipse at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            ShortValid = TRUE;
            SetParams(3);
         }
         else if (PhaseStr == "A") {
            Print("Short valid - Full moon at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            ShortValid = TRUE;
            SetParams(2);
         }
         else if (PhaseStr == "F") {
            Print("Short valid - Perigee moon at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
            ShortValid = TRUE;
            SetParams(2);
         }
         if (ShortValid)
            ReadMoonPhase(TimeCurrent() + 1);
      }
         
      if ((TimeDayOfWeek(TimeCurrent()) == 5) && (TimeDay(TimeCurrent()) == 13)) {     // Today is Friday 13th?
         Print("Short valid - Friday 13th at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
         EntryType = ENTRY_FRIDAY_THIRTEEN;
         ShortValid = TRUE;
         ShortFinished = TRUE;                          // Prevent another entry today
         SetParams(3);
      }
   
      if (ShortValid) {
         if (!CheckFilters(TRUE, EntryType)) {
            Orders[UnitNumber][ORDER_NO] = MarketOrder(Symbol(), OP_SELL, Bid, PositionSize(),
                     Bid - Points * Target, Bid + Points * Stop);
            if (Orders[UnitNumber][ORDER_NO] > 0) {
               Print("Opened short ", Bid, " at ", TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS));
               Orders[UnitNumber][ORDER_STATUS] = ORDER_FILLED;
               Orders[UnitNumber][ENTRY_TYPE] = EntryType;
               StartTimes[EntryType] = TimeCurrent() + MinRepeatMins * SECS_PER_MIN;
               UnitNumber++;
               ShortValid = FALSE;
               return(true);
            }
         }   
      }
   }
   
   return(false);
}

void SetParams(int Set)
{
   Slippage = MaxSlippage;
   
   switch (Set) {
   case 2:
      Lots = Lots2;
      Target = ProfitTarget2;
      Stop = StopLoss2;
      break;
   case 3:
      Lots = Lots3;
      Target = ProfitTarget3;
      Stop = StopLoss3;
      break;
   default:
      Lots = Lots1;
      Target = ProfitTarget1;
      Stop = StopLoss1;
      break;
   }
      
   if ((Dig == 1) || (Dig == 3) || (Dig == 5)) {
      Slippage *= 10;
      Target *= 10;
      Stop *= 10;
   }
}

//+------------------------------------------------------------------+
//| Checks if an order is closed                                     |
//+------------------------------------------------------------------+
int CheckStatus(int Ticket)
{
   int ErrorCode;

   if (OrderSelect(Ticket, SELECT_BY_TICKET) != TRUE) {
      ErrorCode = GetLastError();
      Print("Error selecting order ", Ticket, " to check: ",
            ErrorDescription(ErrorCode), " (", ErrorCode, ")");
      return(-1);
   }
   else if (OrderCloseTime() > 0) {
      Print("Order ", Ticket, " closed: ", DoubleToStr(OrderClosePrice(), Dig),
            ", at ", TimeToStr(OrderCloseTime()));
      return(2);
   }
   else switch(OrderType()) {
   case OP_BUY:
   case OP_SELL:
      return(1);
   default:
      return(0);
   }
}

//+------------------------------------------------------------------+
//| Checks for exit from a trade                                     |
//+------------------------------------------------------------------+
bool CheckExit()
{
   int OpenOrders = 0;
   int Status;
   int UnitNumber, j;
   double Profit;
   
   for (UnitNumber = 0; UnitNumber < MAX_ORDERS; UnitNumber++) {
      if (Orders[UnitNumber][ORDER_STATUS] < ORDER_CLOSED)
         return(false);
   }
   
   Print("All orders closed at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
      
   return(true);
}

void PrintLuckyNumbers()
{
   int i;
   string outStr;

   Print(DaysLeft, " days ", HoursLeft, " hours to go!");
   
   outStr = StringConcatenate("Lucky numbers are ", LuckyPrices[0]);
   for (i = 1; i < MAX_NOS; i++) {
      if (LuckyPrices[i] < 0)   
         break;
      outStr = StringConcatenate(outStr, ",", LuckyPrices[i]);
   }
   Print(outStr);
   
   outStr = StringConcatenate("Unlucky numbers are ", UnluckyPrices[0]);
   for (i = 1; i < MAX_NOS; i++) {
      if (UnluckyPrices[i] < 0)   
         break;
      outStr = StringConcatenate(outStr, ",", UnluckyPrices[i]);
   }
   Print(outStr);
   
   outStr = StringConcatenate("Unlucky days are ", LongBadDay[0]);
   for (i = 1; i < MAX_NOS; i++) {
      if (LongBadDay[i] < 0)   
         break;
      outStr = StringConcatenate(outStr, ",", LongBadDay[i]);
   }
   Print(outStr);
}
   
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   int i;
   
   StrategyName = StringConcatenate(ROBOT_NAME, " ", VERSION);
   
   Dig = MarketInfo(Symbol(), MODE_DIGITS);
   Points = MarketInfo(Symbol(), MODE_POINT);
   TickSize = MarketInfo(Symbol(), MODE_TICKSIZE);
   StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   MinLots = MarketInfo(Symbol(), MODE_MINLOT);
   MaxLots = MarketInfo(Symbol(), MODE_MAXLOT);
   StepLots = MarketInfo(Symbol(), MODE_LOTSTEP);
   Spread = MarketInfo(Symbol(), MODE_SPREAD);

   Print("Stop Level = ", StopLevel, ", Digits = ", Dig, ", Points = ", DoubleToStr(Points, Dig), ", Spread = ", Spread);
   
   for (i = 0; i < MAX_NOS; i++) {
      if (LuckyPrices[i] < 0) {
         LuckyOffset = i;
         if ((LuckyPrice >= 10) && (LuckyPrice < 1000)) {
            LuckyPrices[i] = LuckyPrice;
            LuckyOffset++;
         }
         else if (LuckyPrice != -1)
            Alert("LuckyPrice must be between 10 and 999!");   
         break;
      }   
   }

   for (i = 0; i < MAX_NOS; i++) {
      if (UnluckyPrices[i] < 0) {
         UnluckyOffset = i;
         if ((UnluckyPrice >= 10) && (UnluckyPrice < 1000)) {
            UnluckyPrices[i] = UnluckyPrice;
            UnluckyOffset++;
         }   
         else if (LuckyPrice != -1)
            Alert("UnluckyPrice must be between 10 and 999!");   
         break;
      }      
   }
   
   for (i = 0; i < MAX_NOS; i++) {
      if (LongBadDay[i] < 0) {
         if ((UnluckyDay >= 1) && (UnluckyDay <= 31))
            LongBadDay[i] = UnluckyDay;
         else if (UnluckyDay != -1)
            Alert("UnluckyDay must be between 1 and 31!");   
         break;
      }      
   }
   
   FinishDate = StrToTime("2013-06-01 16:00");
   
   if (UseMySQL) {
      db_connect();
      LuckyPrices[LuckyOffset] = db_read_lucky();
      UnluckyPrices[UnluckyOffset] = db_read_unlucky();
      if (!db_read_summary())
         db_write_summary();
      else   
         db_update_summary();
      db_disconnect();
   }
            
   MessageBox("Sid the superstitious robot " + VERSION + " Copyright (C) 2012 J. L. Hunt\n\n" + 
         "This expert comes with ABSOLUTELY NO WARRANTY. This is free software, " +
         "and you are welcome to redistribute it under certain conditions.\n" +
         "See http://www.gnu.org/licenses/gpl.html for details.", NULL, MB_OK | MB_ICONINFORMATION);

   if (!IsDemo() && !IsTesting()) {
      MessageBox("Wealth Warning! This expert is for educational purposes only." +
            " It should NEVER be used on a live account." +
            " Past performance is in no way indicative of future results!", NULL, MB_OK | MB_ICONWARNING);
      Print("Initialization Failure");
      return(-1);
   }

   Suffix = StringSubstr(Symbol(), 6);
   Broker = AccountCompany();
   
   if ((Suffix == "SB") && ((StringSubstr(Broker, 0, 10) == "Smart Live") || (StringSubstr(Broker, 0, 4) == "GKFX")))
      SmartFix = TRUE;
   
   MonthlyMinimum = FindMonthlyMinimum();      
   LastMonth = Month();

   InitSystem();
  
   Print("Initialized OK");
   PrintLuckyNumbers();
   
   return(0);
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   for(int i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) {
         switch(OrderType()) {
         case OP_BUY:
         case OP_SELL:
           Alert("Warning - Exiting ", StrategyName, " with order ", OrderTicket(), " still open!");
           break; 
         default:    
            Print("Found order ", OrderTicket(), " with unexpected order type ", OrderType());
            break; 
         }
      }
   }

    Print("Deinitialized OK");
   
    return(0);
}

//+------------------------------------------------------------------+
//| Expert start function                                            |
//| Executed on every tick                                           |
//+------------------------------------------------------------------+
int start()
{
   if (!Initialized) {
      return(-1);
   }
   
   if (AccountEquity() < MonthlyMinimum) {
      EmergencyStop();
   }
   
   if (Bars != LastBar) {
      if (Day() != LastDay) {
         LastDay = Day();
         if (LastMonth != Month()) {
            LastMonth = Month();
            MonthlyMinimum = AccountBalance() * (1 - 0.01 * MaxMonthlyLoss);
            double CalculatedMinimum = FindMonthlyMinimum();
            if (NormalizeDouble(MonthlyMinimum - CalculatedMinimum, 2) != 0.0)
               Alert("Calculated minimum = ", DoubleToStr(CalculatedMinimum, 2), ", account minimum = ", DoubleToStr(MonthlyMinimum, 2));
            else
               Print("Balance at start of month = ", DoubleToStr(AccountBalance(), 2), ", Minimum for this month = ", DoubleToStr(MonthlyMinimum, 2));
               
         }
         LongFinished = FALSE;
         ShortFinished = FALSE;
         datetime StartTime = TimeCurrent() - mod(TimeCurrent(), SECS_PER_DAY);
         for (int i = 0; i < MAX_ENTRIES; i++) {
            StartTimes[i] = StartTime;
         } 
         FinishTime = StartTime + FinishHour * SECS_PER_HOUR + FinishMins * SECS_PER_MIN;
         CloseTime = StartTime + CloseHour * SECS_PER_HOUR + CloseMins * SECS_PER_MIN;
         ReadMoonPhase(StartTime);
      }
      LastBar = Bars;
   }

   CheckOrders();
   
   if (CheckEntry() > 0) {                // Entered a trade?
      Running = TRUE;                     // Yes - Indicate that we're in a trade
   }
      
   if (Running) {                         // Are we in a trade at the moment?
      if (UseMySQL && !IsTesting()) {
         if (TimeCurrent() > NextSummary) {
            db_connect();
            db_update_summary();
            db_disconnect();
         }
      }
   
      if (CheckExit()) {                  // Yes - Last trade complete?
         Initialized = FALSE;             // Yes - Indicate we need to reinitialise
         InitSystem();                    //  and start all over again!
      }
   }

   return(0);
}

